USE ROLE SFLK_CATALOGUER;
USE WAREHOUSE DEMO_WH;
USE SCHEMA UTIL_DB.SFLK_CATALOG;

CREATE OR REPLACE TRANSIENT TABLE QUERIES_TABLES_LINK AS
 SELECT QUERY_ID, QUERY_ID_WIDX, T_FULLNAME, TABLE_ID
 FROM QUERIES_WITH_MULTIPLE_TABLES;

//Based on the query determine the users & roles that have
//interacted with the table
CREATE OR REPLACE TRANSIENT TABLE TABLE_ROLE_INTERACTION AS 
SELECT T.T_FULLNAME, T.TABLE_ID,
    LISTAGG( DISTINCT Q.USER_NAME, '|' ) queried_users,
    LISTAGG( DISTINCT Q.ROLE_NAME, '|' ) queried_roles
FROM QUERIES_TABLES_LINK T
    JOIN ACCOUNT_USAGE_QUERY_HISTORY Q ON Q.QUERY_ID = T.QUERY_ID
GROUP BY T.T_FULLNAME, T.TABLE_ID
    ;


// This gives an insight into no of queries that the table is part
// of. This will help us identify heavily used tables
CREATE OR REPLACE TRANSIENT TABLE TABLES_META_PROFILED AS
  WITH TABLE_LAST_ACCESSED AS (
    SELECT Q.TABLE_ID, TO_DATE(MAX(X.START_TIME)) LAST_ACCESS_TIME
    FROM QUERIES_W_RELATED_TABLES Q
        JOIN ACCOUNT_USAGE_QUERY_HISTORY X
            ON X.QUERY_ID = Q.QUERY_ID
    GROUP BY Q.TABLE_ID

 ), TABLE_COUNT as (
    SELECT Q.T_FULLNAME, Q.TABLE_ID, LAST_ACCESS_TIME,
         COUNT(QUERY_ID_WIDX) AS MULTI_TBL_QUERIES_USAGE_COUNT
    FROM QUERIES_WITH_MULTIPLE_TABLES Q
        JOIN TABLE_LAST_ACCESSED T
            ON T.TABLE_ID = Q.TABLE_ID
    GROUP BY T_FULLNAME, Q.TABLE_ID, LAST_ACCESS_TIME
 )
    SELECT T.*, Q.LAST_ACCESS_TIME, Q.MULTI_TBL_QUERIES_USAGE_COUNT,  
        TRI.QUERIED_USERS, TRI.QUERIED_ROLES
    FROM ACTIVE_TABLES_VIEWS AS T
        LEFT OUTER JOIN TABLE_COUNT AS Q ON Q.TABLE_ID = T.TABLE_ID
        LEFT OUTER JOIN TABLE_ROLE_INTERACTION AS TRI ON TRI.TABLE_ID = T.TABLE_ID
;

// STEP 7 : This defines the link between 2 tables and the no of queries they
// are referred in. The higher the link_count the tighter the relationship.
CREATE OR REPLACE TRANSIENT TABLE TABLE_NEIGHBOURS AS
    SELECT LEAST(L.T_FULLNAME, R.T_FULLNAME) || ' | ' ||  GREATEST(L.T_FULLNAME, R.T_FULLNAME) NEIGHBOUR_TABLES,
         COUNT(*) LINK_COUNT
      FROM QUERIES_WITH_MULTIPLE_TABLES L
          JOIN QUERIES_WITH_MULTIPLE_TABLES R ON L.QUERY_ID_WIDX = R.QUERY_ID_WIDX
      WHERE L.T_FULLNAME != R.T_FULLNAME
      GROUP BY NEIGHBOUR_TABLES
      ORDER BY LINK_COUNT DESC
;

// Determines which columns are used in queries. This gives a sense of
// crucial columns vs columns which are least or not used at all.
CREATE OR REPLACE TRANSIENT TABLE TABLE_COLUMNS_USAGE AS
WITH TABLES_COLS AS (
    SELECT DISTINCT T_FULLNAME, TABLE_ID,
         ARRAY_AGG( COL_FULLNAME ) OVER ( PARTITION BY TABLE_ID) COLS
    FROM ACTIVE_COLUMNS

  ), TBLS_COLS_QRY_RELN_AGG AS (
    SELECT
      QUERY_ID_WIDX,
      FN_GET_COLS_BASEDON_ALIAS(QRY_TEXT, T_CATALOG, T_SCHEMA) COLS_FROM_ALIAS,
      FN_GET_MENTIONED_COLS(Q.T_FULLNAME, T.COLS, COLS_FROM_ALIAS, TKNS) MENTOINED_COLS,
      Q.T_FULLNAME, TABLE_CATALOG_ID, TABLE_SCHEMA_ID, Q.TABLE_ID
    FROM QUERIES_WITH_MULTIPLE_TABLES Q
    JOIN TABLES_COLS T ON T.TABLE_ID = Q.TABLE_ID
    WHERE ARRAY_SIZE(MENTOINED_COLS) > 0

  ), TBLS_COLS_QRY_RELN AS (
    SELECT Q.T_FULLNAME, Q.TABLE_CATALOG_ID, Q.TABLE_SCHEMA_ID, Q.TABLE_ID,
        T.VALUE COL_FULLNAME, QUERY_ID_WIDX
        //COUNT( Q.QUERY_ID_WIDX )OVER ( PARTITION BY Q.T_FULLNAME ) COL_USAGE_COUNT
    FROM TBLS_COLS_QRY_RELN_AGG Q,
        TABLE(FLATTEN(INPUT => MENTOINED_COLS)) T

  ), TBL_COLS_COUNTED AS (
    SELECT Q.COL_FULLNAME, Q.T_FULLNAME, Q.TABLE_CATALOG_ID,
           Q.TABLE_SCHEMA_ID, Q.TABLE_ID,
           count(QUERY_ID_WIDX) COL_USAGE_COUNT
    FROM TBLS_COLS_QRY_RELN Q
    GROUP BY Q.COL_FULLNAME, Q.T_FULLNAME, Q.TABLE_CATALOG_ID,
             Q.TABLE_SCHEMA_ID, Q.TABLE_ID
  )
  SELECT C.*, COALESCE(Q.COL_USAGE_COUNT, 0) COL_USAGE_COUNT
  FROM TBL_COLS_COUNTED Q
      RIGHT OUTER JOIN ACTIVE_COLUMNS C
        ON C.TABLE_ID = Q.TABLE_ID
        AND C.COL_FULLNAME = Q.COL_FULLNAME
  
;



